;AVR Timer
; 1.00 eng
;:  ..
;  LCD    .
; 1.
;    .
;LCD  .

.include	"tn26def.inc"	;  

.list						; 

.def	adc255 		= R0	;   (0...255)
.def	adc99 		= R1	;   (0...99)
.def	edinicy 	= R2	;  (3)
.def	desyatki	= R3	;  (4)
.def	adc0 		= R4	;    (0...99)
.def	adc1		= R5	;    (0...59)
.def	c1 			= R6	; c1
.def	star_p		= R6	;      
.def	mlad_p 		= R7	;      
.def	c4 			= R8	; c3
.def	c3 			= R9	; c4
;--------------------------------------------------------
.def	work 		= R16	;   (0 - , 1 - , 2 - , 3 - )
.def	temp 		= R17	;   
.def	temp2 		= R18	;   
.def	lcd			= R19	;     LCD
.def	star 		= R20	;   
.def	mlad 		= R21	;   
.def	lcd2 		= R22	;    LCD
.def	flg 		= R23	;  
.def	cikl		= R24	;  (0 - , 1 - )
.def	koef		= R25	;     /

;--------------------------------------------------------
.equ	d20m	= 7			;   (~20  20) (-9)/6
.equ	d40u	= 12		;   (~40  20) (-4)/3
.equ	RS 		= 2			;
.equ	E 		= 3			;
.equ	NAGR 	= 0			;
.equ	BUZZER 	= 1			;

;------------------------  ( flg)
.equ	mode	= 0			;    (0=/, 1=/)
.equ	hide	= 1			;    LCD (0=, 1=)
.equ	napr	= 2			;   (0= , 1= )
.equ	freq	= 3			;    (0=1, 1=2)
.equ	comt1	= 4			;        T1
.equ	mute	= 5			;    (0 -  , 1 -  )
.equ	pauson	= 6			;   (0 - , 1 -  )

;------------------------   EEPROM ()
.eseg
.org	0x08			;   

e_flg:
.byte	1				; EEPROM     

e_star_p:
.byte	1				; EEPROM   star_p

e_mlad_p:
.byte	1				; EEPROM   mlad_p

e_koef:
.byte	1				; EEPROM   koef

e_tcnt1:
.byte	1				; EEPROM   TCNT1

e_work:
.byte	1				; EEPROM   work

e_star:
.byte	1				; EEPROM   star

e_mlad:
.byte	1				; EEPROM   mlad
;------------------------   EEPROM ()

;------------------------  

.cseg
.org	0				;    

;------------------------   ()

start:
		rjmp	init	;   
		reti			;  0
		reti			;     
		rjmp	comtim1	;/ 1, ,  
		reti			;/ 1, ,  B
		rjmp	ovtim1	;/ 1,   
		reti			;/ 0,   
		reti			;USI   
		reti			;USI 
		reti			;EEPROM 
		reti			;  
		reti			;  

;------------------------   ()

;-----------------------  ()

init:

;-----------------------  ()

ldi	temp, RAMEND		;   
out	SP, temp			;    

;-----------------------  ()

;----------------------- ADC ()

ldi		temp,0b00000011	;  ,   125 (  8),  
out		ADCSR,temp		;
ldi		temp,0b00111111	;+5,   (8-),   ""
out		ADMUX,temp		;

;----------------------- ADC ()

;-----------------------   ()

ldi		temp,0b10001111	;PB0...PB3,PB7  , PB4,PB5,PB6  
out		DDRB,temp		;   
ldi		temp,0b11000010	; PB0,PB2,PB3,    PB4,PB5, 
						;  PB6,  PB1,PB7 
out		PORTB,temp		;   

ldi		temp,0b11110000	;PA0...PA3  , PA4...PA7  
out		DDRA,temp		;   
ldi		temp,0b00001100	;   PA0,PA1,   PA2,PA3, 
						; PA4...PA7
out		PORTA,temp		;   

;-----------------------   ()

;-----------------------  ()

ldi		lcd,0b00001000	;  
rcall	lcd_com			;     LCD

;-----------------------  ()

;-----------------------  ()

ldi		temp,0b00000000	;  0
out		TCCR0,temp		;

out		TCCR1B,temp		;

ldi		temp,0b00000010	;      ,     
out		TCCR1A,temp		;

;-----------------------  ()

;-----------------------   ()

ldi		temp,0b00000000	;   
out		TIMSK,temp		;

out		GIMSK,temp		;  

ldi		temp,61			;    (1 )
out		OCR1C,temp		;

;-----------------------   ()

;-----------------------  ()

ldi		temp,0x80		; 
out		ACSR,temp		;

;-----------------------  ()

;----------------------- LCD ()

cli						;  

lcd_init:
rcall	del20m			;   (~20)
rcall	del20m			;   (~20)
rcall	del20m			;   (~20)

cbi		PORTB,RS		;: 
nop						; 1
sbi		PORTB,E			; 
nop						; 1
ldi		temp,0b00100000	;
out		PORTA,temp		;   
nop						; 1
cbi		PORTB,E			; 
rcall	del40u			;   (~40)

ldi		lcd,0b00101000	; 00101000
rcall	lcd_com			;     LCD

ldi		lcd,0b00001000	; 00001000
rcall	lcd_com			;     LCD

ldi		lcd,0b00000001	; 00000001
rcall	lcd_com			;     LCD

rcall	del3m			;   (~3)

ldi		lcd,0b00000110	; 00000110
rcall	lcd_com			;     LCD

ldi		lcd,0b00001100	;    
rcall	lcd_com			;     LCD

;-----------------------   ExtSym   LCD ()

ldi		ZL,low(ExtSym*2)	;  ZL       ExtSym ( )
ldi		ZH,high(ExtSym*2)	;  ZH       ExtSym ( )
ldi		lcd2,16			; 16  lcd2
ldi		lcd,0b01000000	;     LCD
push	lcd				; lcd  

symb0:
rcall	lcd_com			;     LCD

lpm		lcd,Z			;  lcd         Z
adiw	Z,1				;  Z  1
mov		temp,lcd		;  lcd  temp
swap	lcd				;  
andi	lcd,0b00001111	; 00001111    
rcall	lcd_dat			;     LCD

pop		lcd				; lcd  
inc		lcd				;  lcd  1
push	lcd				; lcd  

rcall	lcd_com			;     LCD

mov		lcd,temp		;  temp  lcd 
andi	lcd,0b00001111	; 00001111    
rcall	lcd_dat			;     LCD

pop		lcd				; lcd   ( )
dec		lcd2			; lcd2  1
cpi		lcd2,0			; lcd2  0
breq	main			; lcd2=0,   main,  
inc		lcd				;  lcd  1
push	lcd				; lcd  
rjmp	symb0			; symb0

;-----------------------   ExtSym   LCD ()

;----------------------- LCD ()

;-----------------------  ()

main:
ldi		temp2,e_flg		;   e_flg  temp2
rcall	EEPROM_read		;    EEPROM
sei						;  

cpi		temp2,255		; temp2  255 (FF -   EEPROM)
breq	main1			; temp2=255,   main1,  

rcall	ee_imp			;    EEPROM

cpi		work,3			; work  3
brne	main2			; work<>3,   main2,  

sbr		flg,0b01000000	;pauson=1 (  )

rcall	str0			;    	
rjmp	str1_1			; str1_1

main1:
clr		flg				;   

main2:
clr		work			;" " (work=0)

main3:
tst		work			; work  0
breq	izm_napr0		; work=0 ( ),   izm_napr0,   

sbrc	flg,comt1		; comt1=0 (       T1  ),   . 
rjmp	str1_1			; str1_1

rjmp	knop1_on		; knop1_on

;-----------------------    ()

izm_napr0:
ldi		temp,0b00100001	;+5,   (8-),   ADC1
out		ADMUX,temp		;

sbi		ADCSR,ADEN		; 
sbi		ADCSR,ADSC		; 

izm_napr0_1:
sbis	ADCSR,ADIF		; ADIF=1,   . ,  
rjmp	izm_napr0_1
sbi		ADCSR,ADIF

ldi		temp,0b00111111	;+5,   ""
out		ADMUX,temp		;
cbi		ADCSR,ADEN		; 

in		adc255,ADCH		;  adc255     (  8-)

ldi		temp2,41

rcall	d255_d99		;    0...255   0...99
mov		adc0,adc99		;  adc99  adc0

;-----------------------    ()

;-----------------------    ()

izm_napr1:
ldi		temp,0b00100000	;+5,   (8-),   ADC0
out		ADMUX,temp		;

sbi		ADCSR,ADEN		; 
sbi		ADCSR,ADSC		; 

izm_napr1_1:
sbis	ADCSR,ADIF		; ADIF=1,   . ,  
rjmp	izm_napr1_1
sbi		ADCSR,ADIF

ldi		temp,0b00111111	;+5,   ""
out		ADMUX,temp		;
cbi		ADCSR,ADEN		; 

in		adc255,ADCH		;  adc255     (  8-)

ldi		temp2,69

rcall	d255_d99		;    0...255   0...59
mov		adc1,adc99		;  adc99  adc1

;-----------------------    ()

rcall	str0			;    

;-----------------------   ()

str1:
tst		cikl			; cikl  0
breq	str1_0			; cikl=0,   str1_0,  
rjmp	tim_on			; tim_on

str1_0:
rcall	lcd_stop		;      
rjmp	knop1_on

str1_1:
cbr		flg,0b00010000	;comt1=0 (          T1)
sbrs	flg,napr		; napr=1 ( ),   . 
rjmp	str1_3			; str1_3

mov		star_p,adc0		;  adc0  star_p
mov		mlad_p,adc1		;  adc1  mlad_p
sub		mlad_p,mlad		; mlad  mlad_p
brcc	str1_2			;  ,   str1_2,  
ldi		temp,60			; 60  temp
add		mlad_p,temp		; temp  mlad_p
dec		star_p			; star_p  1
clc						;  

str1_2:
sub		star_p,star		; star  star_p,   star_p (c1)

rcall	bin2dec			;      -

ldi		lcd,0xC0		;  ( 2 )
rcall	lcd_com			;     LCD

rcall	disp0			;    

mov		c1,mlad_p		;  mlad_p  c1
rcall	bin2dec			;      -

rcall	disp1			;    

ldi		lcd,0xD9		; " "
rjmp	str1_4			; str1_4

str1_3:
mov		c1,star			;  star  c1
rcall	bin2dec			;      -

ldi		lcd,0xC0		;  ( 2 )
rcall	lcd_com			;     LCD

rcall	disp0			;    

mov		c1,mlad			;  mlad  c1
rcall	bin2dec			;      -

rcall	disp1			;    

ldi		lcd,0xDA		; " "

str1_4:
rcall	lcd_dat			;     LCD

rcall	lcd_work		;     

;-----------------------   ()

;-----------------------    / ()
knop1_on:
sbic	PINA,3			; PA3=0 ( ),   . 
rjmp	knop2_on		; knop2_on
rcall	del3m			;   (~3)
sbic	PINA,3			; PA3=0 ( ),   . 
rjmp	knop2_on		; knop2_on
;-----------------------    / ()

;-----------------------    / ()
knop1_off:
clr		temp			; temp

knop1_off_1:
sbic	PINA,3			; PA3=0 ( ),   . 
rjmp	knop1_off_5		; knop1_off_5
rcall	del3m			;   (~3)
inc		temp			; temp  1
brne	knop1_off_1		;   0,    knop1_off_1
clc						;  

knop1_off_2:
sbrc	flg,napr		; napr=0 ( ),   . 
rjmp	knop1_off_3		; knop1_off_3
sbr		flg,0b00000100	;napr=1 ( )

ldi		ZL,low(Prm*2)	;  ZL       Prm ( )
ldi		ZH,high(Prm*2)	;  ZH       Prm ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   
rjmp	knop1_off_4		; knop1_off_4

knop1_off_3:
cbr		flg,0b00000100	;napr=0 ( )

ldi		ZL,low(Obr*2)	;  ZL       Obr ( )
ldi		ZH,high(Obr*2)	;  ZH       Obr ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   

knop1_off_4:
sbis	PINA,3			; PA3=1 (  ),   . 
rjmp	knop1_off_4		; knop1_off_4

rcall	ee_exp0			;     EEPROM,   

rjmp	str1_1			; str1_1

knop1_off_5:
tst		work			; work  0
breq	knop1_off_7		; work=0,   knop1_off_7,  

cpi		work,3			; work  3
brne	knop1_off_6		; work<>3 (   ),    knop1_off_6,  

knop1_off_5_1:
ldi		work,1			;" " (work=1)

rcall	ee_exp2			;     EEPROM,  work

rjmp	tim_on_2		; tim_on_2

knop1_off_6:			; work=1, 
ldi		temp,0b00000000	;   
out		TIMSK,temp		;

ldi		temp,0b00000000	;  T1 ()
out		TCCR1B,temp		;

ldi		temp,0b00000010	;      ,     
out		TCCR1A,temp		;

ldi		work,3			;"  " (work=3)

rcall	lcd_work		;     

rcall	ee_exp0			;     EEPROM,   
rcall	ee_exp1			;     EEPROM, ,   

rjmp	knop2_on		; knop2_on

knop1_off_7:
sbrc	flg,mode		; mode=0 (/),   . 
rjmp	knop1_off_8
sbr		flg,0b00000001	;mode=1 (/)

rcall	ee_exp0			;     EEPROM,   

rjmp	knop2_on		; knop2_on

knop1_off_8:
cbr		flg,0b00000001	;mode=0 (/)

rcall	ee_exp0			;     EEPROM,   
;-----------------------    / ()

;-----------------------   / ()
knop2_on:
sbic	PINB,6			; PB6=0,   . 
rjmp	knop3_on		; knop3_on
rcall	del3m			;   (~3)
sbic	PINB,6			; PB6=0,   . 
rjmp	knop3_on		; knop3_on
;-----------------------   / ()

;-----------------------   / ()
knop2_off:
clr		temp			; temp

knop2_off_1:
sbic	PINB,6			; PB6=0,   . 
rjmp	tim				; tim
rcall	del3m			;   (~3)
inc		temp			; temp  1
brne	knop2_off_1		;   0,    knop2_off_1

clc						;  
sbrc	flg,mute		; mute=0 ( ),   . 
rjmp	knop2_off_2		; knop2_off_2
sbr		flg,0b00100000	;mute=1 ( )

ldi		ZL,low(Zv_off*2)	;  ZL       Prm ( )
ldi		ZH,high(Zv_off*2)	;  ZH       Prm ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   
rjmp	knop2_off_3		; knop2_off_3

knop2_off_2:
cbr		flg,0b00100000	;mute=0 ( )

ldi		ZL,low(Zv_on*2)		;  ZL       Obr ( )
ldi		ZH,high(Zv_on*2)	;  ZH       Obr ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   

knop2_off_3:
sbis	PINB,6			; PB6=1 (  ),   . 
rjmp	knop2_off_3		; knop2_off_3

rcall	lcd_sgl			;    

rcall	ee_exp0			;     EEPROM,   

rjmp	str1_1			; str1_1
;-----------------------   / ()

;-----------------------   ()
tim:
tst		work			; work  0
breq	tim_on			; work=0 ( ),    tim_on,  

;-----------------------  ()
tim_off:
clr		cikl			; cikl
ldi		temp,0b00000000	;   
out		TIMSK,temp		;

ldi		temp,0b00000000	;  T1
out		TCCR1B,temp		;

ldi		temp,0b00000010	;      ,     
out		TCCR1A,temp		;

clr		temp			;    1
out		TCNT1,temp		;

clr		star			; star
clr		mlad			; mlad

ldi		work,0			;" " (work=0)

sbrs	flg,pauson		; pauson=1 (  ),   . 
rjmp	tim_off_1		; tim_off_1

rcall	ee_exp2			;     EEPROM,  work

tim_off_1:
rjmp	main3			; main3
;-----------------------  ()

;-----------------------  ()
tim_on:

;-----------------------     ()
tst		adc0			; adc0  0
brne	tim_on_1		; adc0<>0,   tim_on_1
tst		adc1			; adc1  0
brne	tim_on_1		; adc0<>1,   tim_on_1

rjmp	tim_off			; tim_off
;-----------------------     ()

tim_on_1:
ldi		koef,60			;       /
mov		star,adc0		; adc0  star
mov		mlad,adc1		; adc1  mlad

tim_on_2:
cbr		flg,0b00000010	;hide=0
ldi		temp,0b01000000	;         T1
out		TIMSK,temp		;

ldi		temp,0b00001111	; , .  16384
out		TCCR1B,temp		;

ldi		work,1			;" " (work=1)
rjmp	str1_1			; str1_1
;-----------------------  ()

;-----------------------   ()

;-----------------------   / ()
knop3_on:
sbic	PINA,2			; PA2=0,   . 
rjmp	main3			; main3
rcall	del3m			;   (~3)
sbic	PINA,2			; PA2=0,   . 
rjmp	main3			; main3
;-----------------------   / ()

;-----------------------   / ()
knop3_off:
clr		temp			; temp

knop3_off_1:
sbic	PINA,2			; PA2=0,   . 
rjmp	knop3_off_4		; knop3_off_4
rcall	del3m			;   (~3)
inc		temp			; temp  1
brne	knop3_off_1		;   0,    knop3_off_1

clc						;  
tst		cikl			; cikl  0
breq	knop3_off_2		; cikl=0,   knop3_off_2,  
clr		cikl			;cikl=0 ()

ldi		ZL,low(Ckl_n*2)		;  ZL       Ckl_n ( )
ldi		ZH,high(Ckl_n*2)	;  ZH       Ckl_n ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   

knop3_off_1_1:
sbis	PINA,2			; PA2=1 (  ),   . 
rjmp	knop3_off_1_1	; knop3_off_1_1
rjmp	tim_off			; tim_off

knop3_off_2:
ldi		cikl,1			;cikl=1 ()

ldi		ZL,low(Ckl_d*2)		;  ZL       Ckl_d ( )
ldi		ZH,high(Ckl_d*2)	;  ZH       Ckl_d ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   

knop3_off_3:
sbis	PINA,2			; PA2=1 (  ),   . 
rjmp	knop3_off_3		; knop3_off_3

rcall	lcd_sgl			;    

sbrc	flg,pauson		; pauson=0 ( ),   . 
rjmp	knop1_off_5_1	; knop1_off_5_1

rjmp	main3			; main3

knop3_off_4:
rcall	n_trig			;   

rjmp	main3			; main3

;-----------------------   / ()

;-----------------------  ()

;-----------------------    LCD ()
lcd_com:
cbi		PORTB,RS		;: 
rcall	lcd_out			;  lcd_out
ret						;  
;-----------------------    LCD ()

;-----------------------    LCD ()
lcd_dat:
sbi		PORTB,RS		;: 
rcall	lcd_out			;  lcd_out
ret						;  
;-----------------------    LCD ()

;-----------------------   LCD ()
lcd_out:
nop						; 1
sbi		PORTB,E			; 
push	lcd				; lcd  
andi	lcd,0b11110000	; 11110000    
ori		lcd,0b00001100	;   PA2,PA3
out		PORTA,lcd		;   
nop						; 1
cbi		PORTB,E			; 
rcall	del40u			;   (~40)

sbi		PORTB,E			; 
pop		lcd				; lcd  
swap	lcd				;  
andi	lcd,0b11110000	; 11110000    
ori		lcd,0b00001100	;   PA2,PA3
out		PORTA,lcd		;   
nop						; 1
cbi		PORTB,E			; 
rcall	del40u			;   (~40)
rcall	del40u			;   (~40)
ret						;  
;-----------------------   LCD ()

;-----------------------  ~40  1 ()
;    (3*d40u)+4

del40u:
ldi		temp2,d40u		; d40u  temp2

del40u_1:
dec		temp2			; temp2  1
brne	del40u_1		;    0,    del40u_1
ret						;  
;-----------------------  ~40  1 ()


;-----------------------  ~769  1 ()
;    (3*255)+4

del769u:
ldi		temp2,255		; 255  temp2

del769u_1:
dec		temp2			; temp2  1
brne	del769u_1		;    0,    del769u_1
ret						;  
;-----------------------  ~769  1 ()

;-----------------------  ~3,092  1 ()
;    4*(769+3)+4

del3m:
rcall	del769u			;   (~769)
rcall	del769u			;   (~769)
rcall	del769u			;   (~769)
rcall	del769u			;   (~769)
ret						;  
;-----------------------  ~3,092  1 ()

;-----------------------  ~20  1 ()
del20m:
ldi		temp,d20m		; 

del20m_1:
rcall	del3m			;   (~3)
dec		temp			; temp  1
cpi		temp,0			; temp  0
brne	del20m_1		; temp<>0,   del20m_1,  
ret						;  
;-----------------------  ~20  1 ()

;-----------------------  8    - ()
;    c1,   desyatki, edinicy
bin2dec:
clr		desyatki		; 
clr		edinicy			; 

desyatki1:
ldi		temp,10			; 10  temp
sub		c1,temp			; 10
brcs	desyatki2		;   ,    desyatki2
inc		desyatki		;   1  
rjmp	desyatki1		; desyatki1

desyatki2:
add		c1,temp			; 10   
mov		edinicy,c1		;   edinicy

ret						;  
;-----------------------  8    - ()

;-----------------------   0...255   0...59..99 ()
;   adc255,   adc99
d255_d99:

;-----------------------  16     ()
d255_d99_0:
clr		temp			; temp
lsl		adc255			;*2 ( *2)
rol		temp			;
lsl		adc255			;*2 ( *4)
rol		temp			;
lsl		adc255			;*2 ( *8)
rol		temp			;
lsl		adc255			;*2 ( *16)
rol		temp			;
;-----------------------  16     ()

clr		adc99			; adc99

d255_d99_1:
sub		adc255,temp2	; 41  adc255
sbci	temp,0			; 0  temp  
brcs	d255_d99_2		;   ,    d255_d99_2
inc		adc99			;   1  adc99
rjmp	d255_d99_1		; d255_d99_1

d255_d99_2:
ret						;  
;-----------------------   0...255   0...59..99 ()

;-----------------------    ()
disp0:
tst		desyatki		; desyatki  0
breq	disp0_1			; desyatki=0,   disp0_1,  

ldi		lcd,0x30		;    
add		lcd,desyatki	;
rcall	lcd_dat			;     LCD
rjmp	disp0_2			; disp0_2

disp0_1:
ldi		lcd,0x20		;  
rcall	lcd_dat			;     LCD
tst		edinicy			; edinicy  0
breq	disp0_3			; edinicy=0,   disp0_3,  

disp0_2:
ldi		lcd,0x30		;    
add		lcd,edinicy		;
rcall	lcd_dat			;     LCD
rjmp	disp0_4			; disp0_4

disp0_3:
ldi		lcd,0x20		;  
rcall	lcd_dat			;     LCD

ldi		lcd,0x20		;  
rcall	lcd_dat			;     LCD
rjmp	disp0_6

disp0_4:
sbrc	flg,mode		; mode=0 (/),   . 
rjmp	disp0_5			; disp1_1

ldi		lcd,0x6D		; "m"
rcall	lcd_dat			;     LCD
rjmp	disp0_6			; disp0_6

disp0_5:
ldi		lcd,0x68		; "h"
rcall	lcd_dat			;     LCD
rjmp	disp0_6			; disp0_6

disp0_6:
ret						;  
;-----------------------    ()

;-----------------------    ()
disp1:
ldi		lcd,0x30		;    
add		lcd,desyatki	;
rcall	lcd_dat			;     LCD

ldi		lcd,0x30		;    
add		lcd,edinicy		;
rcall	lcd_dat			;     LCD

sbrc	flg,mode		; mode=0 (/),   . 
rjmp	disp1_1			; disp1_1

ldi		lcd,0x73		; "s"
rcall	lcd_dat			;     LCD
rjmp	disp1_2			; disp1_2

disp1_1:
ldi		lcd,0x6D		; "m"
rcall	lcd_dat			;     LCD

disp1_2:
ret						;  
;-----------------------    ()

;-----------------------    ()
lcd_sgl:
ldi		lcd,0x86		;  (7- 1 )
rcall	lcd_com			;     LCD

tst		cikl			; cikl  0
breq	lcd_sgl_0		; cikl=0,   lcd_sgl_0,  
ldi		lcd,0x00		;   00 ()
rjmp	lcd_sgl_2		; lcd_sgl_2

lcd_sgl_0:
sbrs	flg,mute		; mute=1 ( ),   . 
rjmp	lcd_sgl_1		; lcd_sgl_1
ldi		lcd,0x20		; 
rjmp	lcd_sgl_2		; lcd_sgl_2

lcd_sgl_1:
ldi		lcd,0xED		;   ED ( )

lcd_sgl_2:
rcall	lcd_dat			;     LCD
ret						;  
;-----------------------    ()

;-----------------------    ()
lcd_nagr:
ldi		lcd,0x87		;  (8- 1 )
rcall	lcd_com			;     LCD

sbis	PINB,NAGR		; PB0=1,   . 
rjmp	lcd_nagr_1		; lcd_nagr_1
ldi		lcd,0x2A		; "*"
rjmp	lcd_nagr_2		; lcd_nagr_2

lcd_nagr_1:
ldi		lcd,0x20		; 

lcd_nagr_2:
rcall	lcd_dat			;     LCD
ret						;  
;-----------------------    ()

;-----------------------     ()
lcd_work:
ldi		lcd,0xC7		;  ( 2 )
rcall	lcd_com			;     LCD

tst		work			; work  0
breq	lcd_work_1		; work=0 ( ),   lcd_work_1,   

cpi		work,1			; work  1
breq	lcd_work_4		; work=1 ( ),   lcd_work_4,   

cpi		work,2			; work  2
breq	lcd_work_2		; work=1 ( ),   lcd_work_2,   

ldi		lcd,0x02		;   02 (  )
rjmp	lcd_work_6		; lcd_work_6

lcd_work_1:
ldi		lcd,0x03		;   03 ( )
rjmp	lcd_work_6		; lcd_work_6

lcd_work_2:
sbrs	flg,mute		; mute=1 ( ),   . 
rjmp	lcd_work_3		; lcd_work_3
ldi		lcd,0x20		; 
rjmp	lcd_work_6		; lcd_work_6

lcd_work_3:
ldi		lcd,0xED		;   ED ( )
rjmp	lcd_work_6		; lcd_work_6

lcd_work_4:
sbrs	flg,hide		; hide=1,   . 
rjmp	lcd_work_5		; lcd_work_5
ldi		lcd,0x20		; 
rjmp	lcd_work_6		; lcd_work_6

lcd_work_5:
ldi		lcd,0x01		;   01 ( )

lcd_work_6:
rcall	lcd_dat			;     LCD
ret						;  
;-----------------------     ()

;-----------------------      ()
lcd_stop:
ldi		ZL,low(Stop*2)	;  ZL       Stop ( )
ldi		ZH,high(Stop*2)	;  ZH       Stop ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   
rcall	lcd_napr		;    
ldi		lcd,0x03		;   07 ( )
rcall	lcd_dat			;     LCD
ret						;  
;-----------------------      ()

;-----------------------    ()
lcd_napr:
ldi		lcd,0xC6		;  (7-  2 )
rcall	lcd_com			;     LCD

sbrc	flg,napr		; napr=0 ( ),   . 
rjmp	lcd_napr_1		; lcd_napr_1
ldi		lcd,0xDA		; " "
rjmp	lcd_napr_2		; lcd_napr_2

lcd_napr_1:
ldi		lcd,0xD9		; " "

lcd_napr_2:
rcall	lcd_dat			;     LCD
ret						;  
;-----------------------    ()

;-----------------------    LCD ()
lcd_mess:
ldi		lcd2,8			; 8  lcd2
cpi		temp,1			; temp  1
brne	lcd_mess_2str	; str   1,   lcd_mess_2str,  

lcd_mess_1str:
ldi		lcd,0x80		;  ( 1 )
rcall	lcd_com			;
rjmp	lcd_mess_0		; lcd_mess_0

lcd_mess_2str:
ldi		lcd,0xC0		;  ( 2 )
rcall	lcd_com			;

lcd_mess_0:
lpm		lcd,Z			; lcd         Z
adiw	Z,1				;  Z  1
rcall	lcd_dat			;     LCD
dec		lcd2			; lcd2  1
cpi		lcd2,0			; lcd2  0
brne	lcd_mess_0		; lcd2<>0,   lcd_mess_0,  
ret						;  
;-----------------------    LCD ()

;-----------------------    ()
sgl_out:
push	temp			; temp  
push	temp2			; temp2  
push	lcd				; lcd  

ldi		temp,0b00000000	;   
out		TIMSK,temp		;

ldi		temp,0b00000000	;  1
out		TCCR1B,temp		;

clr		temp			;    1
out		TCNT1,temp		;

rcall	n_trig			;   

rcall	lcd_nagr

sbrs	flg,pauson		; pauson=1 (  ),   . 
rjmp	sgl_out1		; sgl_out1

rcall	ee_exp2			;     EEPROM,  work

sgl_out1:
ldi		work,2			;" " (work=2)

tst		cikl			; cikl  0
breq	sgl_out1_1		; cikl=0,   sgl_out1_1,  
rjmp	sgl_out7		; sgl_out7

sgl_out1_1:
ldi		ZL,low(Sgl*2)	;  ZL       Sgl ( )
ldi		ZH,high(Sgl*2)	;  ZH       Sgl ( )
ldi		temp,2			; 2- 
rcall	lcd_mess		;   

rcall	lcd_napr		;    

rcall	lcd_work		;     

sbrc	flg,mute		; mute=0 ( ),   . 
rjmp	sgl_out2		; sgl_out2

ldi		temp,0b00000100	;     1
out		TIMSK,temp		;

ldi		temp,0b11000010	;      1  PB1,     
out		TCCR1A,temp		;

ldi		temp,30			;
out		OCR1A,temp		;

sei						;  

ldi		temp,0b10000011	;  T1, .  4 ( 1)
out		TCCR1B,temp		;

;-----------------------   / ()
sgl_out2:
sbic	PINB,6			; PB6=0,   . 
rjmp	sgl_out4		; sgl_out4
rcall	del3m			;   (~3)
sbic	PINB,6			; PB6=0,   . 
rjmp	sgl_out4		; sgl_out4
;-----------------------   / ()

;-----------------------   / ()
sgl_out3:
sbis	PINB,6			; PB6=1,   . 
rjmp	sgl_out3		; sgl_out3
rcall	del3m			;   (~3)
sbis	PINB,6			; PB6=1,   . 
rjmp	sgl_out3		; sgl_out3
rjmp	sgl_out7		; sgl_out7
;-----------------------   / ()

;-----------------------   / ()
sgl_out4:
sbic	PINA,2			; PA2=0,   . 
rjmp	sgl_out2		; sgl_out2
rcall	del3m			;   (~3)
sbic	PINA,2			; PA2=0,   . 
rjmp	sgl_out2		; sgl_out2
;-----------------------   / ()

;-----------------------   / ()
sgl_out5:
sbis	PINA,2			; PA2=1,   . 
rjmp	sgl_out5		; sgl_out5
rcall	del3m			;   (~3)
sbis	PINA,2			; PA2=1,   . 
rjmp	sgl_out5		; sgl_out5

rcall	n_trig			;   

rjmp	sgl_out2		; sgl_out2
;-----------------------   / ()

sgl_out7:
ldi		work,0			;" " (work=0)

ldi		temp,0b00000000	;   
out		TIMSK,temp		;

ldi		temp,0b00000000	;  1
out		TCCR1B,temp		;

ldi		temp,0b00000010	;      ,     
out		TCCR1A,temp		;

clr		temp			;    1
out		TCNT1,temp		;

sbi		PORTB,BUZZER	;

pop		lcd				; lcd  
pop		temp2			; temp2  
pop		temp			; temp  
ret						;  
;-----------------------    ()

;-----------------------    ()
str0:
mov		c1,adc0			;  adc0  c1
rcall	bin2dec			;      -

ldi		lcd,0x80		;  ( 1 )
rcall	lcd_com			;     LCD

rcall	disp0			;    

mov		c1,adc1			;  adc1  c1
rcall	bin2dec			;      -

rcall	disp1			;    

rcall	lcd_sgl			;    

rcall	lcd_nagr		;    

ret						;  
;-----------------------    ()

;-----------------------   EEPROM,    ()
ee_exp0:
mov		temp,flg		; flg  temp
ldi		temp2,e_flg		;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM
ret						;  
;-----------------------   EEPROM,    ()

;-----------------------   EEPROM, ,    ()
ee_exp1:
cbr		flg,0b01000000	;pauson=0 ( )

mov		temp,star_p		; star_p  temp
ldi		temp2,e_star_p	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,mlad_p		; mlad_p  temp
ldi		temp2,e_mlad_p	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,koef		; koef  temp
ldi		temp2,e_koef	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

in		temp,TCNT1		; TCNT1  temp
ldi		temp2,e_tcnt1	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,work		; work  temp
ldi		temp2,e_work	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,star		; star  temp
ldi		temp2,e_star	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

mov		temp,mlad		; mlad  temp
ldi		temp2,e_mlad	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM
ret						;  
;-----------------------   EEPROM ()


;-----------------------   EEPROM,  work ()
ee_exp2:
cbr		flg,0b01000000	;pauson=0 ( )

mov		temp,work		; work  temp
ldi		temp2,e_work	;  temp2   EEPROM
rcall	EEPROM_write	;    EEPROM

ret						;  
;-----------------------   EEPROM,  work ()


;-----------------------   EEPROM ()
ee_imp:
ldi		temp2,e_flg		;   e_flg  temp2
rcall	EEPROM_read		;    EEPROM
mov		flg,temp2		;  temp2  flg 

ldi		temp2,e_star_p	;   e_star_p  temp2
rcall	EEPROM_read		;    EEPROM
mov		star_p,temp2	;  temp2  star_p 

ldi		temp2,e_mlad_p	;   e_mlad_p  temp2
rcall	EEPROM_read		;    EEPROM
mov		mlad_p,temp2	;  temp2  mlad_p 

ldi		temp2,e_koef	;   e_koef  temp2
rcall	EEPROM_read		;    EEPROM
mov		koef,temp2		;  temp2  koef 

ldi		temp2,e_tcnt1	;   e_tcnt1  temp2
rcall	EEPROM_read		;    EEPROM
out		TCNT1,temp2		;  temp2  TCNT1

ldi		temp2,e_work	;   e_work  temp2
rcall	EEPROM_read		;    EEPROM
mov		work,temp2		;  temp2  koef 

ldi		temp2,e_star	;   e_star  temp2
rcall	EEPROM_read		;    EEPROM
mov		star,temp2		;  temp2  star
mov		adc0,temp2		;  temp2  adc0 

ldi		temp2,e_mlad	;   e_mlad  temp2
rcall	EEPROM_read		;    EEPROM
mov		mlad,temp2		;  temp2  mlad 
mov		adc1,temp2		;  temp2  adc1 
ret						;  
;-----------------------   EEPROM ()


;-----------------------    EEPROM ()
;    temp2,    temp
EEPROM_write:
out		EEAR,temp2		;   EEAR
out		EEDR,temp		;    EEDR

EEPROM_write_1:
sbic	EECR,EEWE		; EEWE ,   . 
rjmp	EEPROM_write_1	; EEPROM_write_1
sbi		EECR,EEMWE		;   EEPROM ( EEMWE)
sbi		EECR,EEWE		;    EEPROM ( EEWE)

EEPROM_write_2:
sbic	EECR,EEWE		; EEWE ,   . 
rjmp	EEPROM_write_2	; EEPROM_write_2
ret						;  
;-----------------------    EEPROM ()

;-----------------------   EEPROM ()
;    temp2,    temp2
EEPROM_read:
out		EEAR,temp2		;   EEAR

EEPROM_read_1:
sbic	EECR,EEWE		; EEWE ,   . 
rjmp	EEPROM_read_1	; EEPROM_read_1
sbi		EECR,EERE		;  EEPROM ( EERE)
in		temp2,EEDR		;    temp2
ret						;  
;-----------------------   EEPROM ()

;-----------------------   ()
n_trig:
sbis	PINB,NAGR		; PB0=1,   . 
rjmp	n_trig1			; n_trig1
cbi		PORTB,NAGR		; 
rjmp	n_trig2			; n_trig2

n_trig1:
sbi		PORTB,NAGR		; 

n_trig2:
rcall	lcd_nagr		;    
ret						;  
;-----------------------   ()

;-----------------------         1 ()
comtim1:
push	temp			; temp  
push	temp2			; temp2  
push	lcd				; lcd  
sbr		flg,0b00010000	;comt1=1 (        T1)
sbrs	flg,mode		; mode=1 (/),   . 
rjmp	comtim1_0		; comtim1_0

dec		koef			;  koef  1
tst		koef			; koef  0
brne	comtim1_3		; koef=0,   comtim1_3,  
ldi		koef,60			;     

comtim1_0:
tst		mlad			; mlad  0
brne	comtim1_1		; mlad<>0,   comtim1_1,  

ldi		mlad,59			; mlad=59
dec		star			; star  1
rjmp	comtim1_3		; comtim1_3

comtim1_1:
dec		mlad			; mlad  1
tst		mlad			; mlad  0
brne	comtim1_3		; mlad<>0,   comtim1_3,  

tst		star			; star  0
breq	comtim1_2		; star=0,   comtim1_2,  
rjmp	comtim1_3		; comtim1_3

comtim1_2:
rcall	sgl_out			;    

cbr		flg,0b00010000	;comt1=0 (          T1)

comtim1_3:
sbrc	flg,hide		; hide=0 ( ),   . 
rjmp	comtim1_4		; comtim1_4
sbr		flg,0b00000010	;hide=1 ( )
rjmp	comtim1_5		; comtim1_5

comtim1_4:
cbr		flg,0b00000010	;hide=0 ( )

comtim1_5:

pop		lcd				; lcd  
pop		temp2			; temp2  
pop		temp			; temp  
reti					;    
;-----------------------         1 ()

;-----------------------      1 ()
ovtim1:
inc		c3				; c3  1
brne	ovtim3			; c3<>0,    ovtim3

sbrc	flg,freq		; freq=0 ( 1),   . 
rjmp	ovtim2			; ovtim2
sbr		flg,0b00001000	;freq=1 ( 2)

ldi		temp,0b10000010	;  T1, .  2 ( 2)
out		TCCR1B,temp		;
rjmp	ovtim3			; ovtim3

ovtim2:
cbr		flg,0b00001000	;freq=0 ( 1)
ldi		temp,0b10000011	;  T1, .  4 ( 1)
out		TCCR1B,temp		;

ovtim3:
reti					;    
;-----------------------      1 ()

;-----------------------  ()
ExtSym:
.db	0x08,0x88,0xE0,0x00,0x8C,0xEF,0xEC,0x80 	;0-  1- 
.db	0x99,0x99,0x99,0x90,0xFF,0xFF,0xFF,0xF0 	;2-  3- 

Sgl:
.db	0x52,0x45,0x41,0x44,0x59,0x20,0x20,0x20		;"READY   "

Stop:
.db	0x53,0x54,0x4F,0x50,0x20,0x20,0x20,0x20		;"STOP   "

Ckl_d:
.db	0x4C,0x4F,0x4F,0x50,0x20,0x20,0x20,0x20		;"LOOP    "

Ckl_n:
.db	0x4E,0x4F,0x20,0x4C,0x4F,0x4F,0x50,0x20		;"NO LOOP "

Prm:
.db	0x43,0x6F,0x75,0x6E,0x74,0x55,0x70,0x20		;"CountUp "

Obr:
.db	0x43,0x6F,0x75,0x6E,0x74,0x44,0x77,0x6E		;"CountDwn"

Zv_on:
.db	0x41,0x4C,0x41,0x52,0x4D,0x20,0x20,0x20		;"ALARM"

Zv_off:
.db	0x4E,0x4F,0x20,0x41,0x4C,0x41,0x52,0x4D		;"NO ALARM"

;-----------------------  ()
